//
//  NSSortDescriptor-Extensions.m
//
//  Created by Scott Stevenson on Tue Mar 13 2005.
//  Copyright (c) 2005 Tree House Ideas. All rights reserved.
//

#import "NSSortDescriptor-Extensions.h"


@implementation  NSSortDescriptor (CDCAdditions)


+ (NSArray *) ascendingDescriptorsForKeys: (NSString *)firstKey,...
{
    
    NSMutableArray    * returnArray   = [[NSMutableArray arrayWithCapacity: 5] retain];
    va_list           keyList;
    
    NSString          * oneKey;
    NSSortDescriptor  * oneDescriptor;
    
    if (firstKey)
    {
        oneDescriptor = [[NSSortDescriptor alloc] initWithKey: firstKey
                                                    ascending: YES];
        [returnArray addObject: oneDescriptor];
        [oneDescriptor release];
        
        va_start (keyList, firstKey);
        
        while (oneKey = va_arg(keyList, NSString *))
        {
            oneDescriptor = [[NSSortDescriptor alloc] initWithKey:oneKey ascending:YES];                           
            [returnArray addObject: oneDescriptor];
            [oneDescriptor release];
        }
        
        va_end (keyList);
    }
    
    return [returnArray autorelease];
    
}

@end